// Preprocessor directives
#ifndef STANDARD_CONSTANTS_H
#define STANDARD_CONSTANTS_H

// Boolean support
#include <stdbool.h>

// global constants

// constant for end of c-string null character
#define CARRIAGE_RETURN_CHAR '\r'

// constant for colon
#define COLON ':'

// constant for comma
#define COMMA ','

// constant for large string length
#define LARGE_STR_LEN 96

// constant for small string length
#define MIN_STR_LEN 32

// constant for maximum string length
#define MAX_STR_LEN 128

// constant for end of c-string null character
#define NEWLINE_CHAR '\n'

//constant for no process (X)
#define NO_PROCESS -1

// constant for default non printable character
#define NON_PRINTABLE_CHAR (char)127

// constant for end of c-string null character
#define NULL_CHAR '\0'

// constant for period character
#define PERIOD '.'

//constant for read only (fopen)
#define READ_ONLY_FLAG "r"

//constant for write only (fopen)
#define WRITE_ONLY_FLAG "w"

// constant for semicolon
#define SEMICOLON ';'

// constant for space character
#define SPACE ' '

// constant for standard string length
#define STD_STR_LEN 64

// constant for standard string length
#define STR_EQ 0

// constant for substring search failure
#define SUBSTRING_NOT_FOUND -1

#endif  // STANDARD_CONSTANTS


